diff -d -u -r kibble/main_window.h kibble-0.7.2/main_window.h
--- kibble/main_window.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/main_window.h	Mon Mar  8 17:56:45 1999
@@ -1,5 +1,5 @@
 /* main_window.h
- * $Id: main_window.h,v 0.1 1998/11/17 03:44:35 joseph Exp $
+ * $Id: main_window.h,v 0.2 1998/12/21 04:23:33 joseph Exp $
  */
 
 /* kibble
@@ -20,4 +20,4 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */
 
-GtkWidget* create_window_main (void);
+extern GtkWidget* create_window_main	(void);
Only in kibble: modal_hack.c
Only in kibble: modal_hack.h
diff -d -u -r kibble/view_dialog.c kibble-0.7.2/view_dialog.c
--- kibble/view_dialog.c	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/view_dialog.c	Mon Mar  8 17:56:44 1999
@@ -1,5 +1,5 @@
 /* view_dialog.c
- * $Id: view_dialog.c,v 0.12 1998/12/05 02:53:40 joseph Exp $
+ * $Id: view_dialog.c,v 0.16 1999/02/05 05:49:39 joseph Exp $
  */
 
 /* kibble
@@ -22,85 +22,114 @@
 
 #include "all.h"
 
-/* This variable does not necessarily have to be global. */
-GtkWidget *dialog_view;
-
-void on_button_view_okay_clicked (GtkButton *button, gpointer user_data)
+static void on_button_view_okay_clicked (GtkButton *button, gpointer user_data)
 {
-	node *tree_node = gtk_object_get_data (GTK_OBJECT
+	GtkWidget *dialog_view;
+	GtkWidget *current_tree_item;
+	node *tree_node;
+
+	debug_msg ("view okay button clicked\n");
+
+	dialog_view = user_data;
+	g_assert (GTK_IS_WINDOW (dialog_view) != 0);
+
+	current_tree_item = GTK_WIDGET (gtk_object_get_data (GTK_OBJECT 
+				(dialog_view), "tree item"));
+	g_assert (current_tree_item != NULL);
+	if (GTK_IS_TREE_ITEM (current_tree_item) != 1) {
+		show_message_box ("Error!\n\n"
+				"Tree item no longer exists?\n"
+				"Aborting view operation\n");
+		gtk_object_destroy (GTK_OBJECT (dialog_view));
+		return;
+	}
+
+	tree_node = gtk_object_get_data (GTK_OBJECT
 			(current_tree_item), "node");
 
-	g_string_assign (tree_node->name, TEXT_DATA ("name", dialog_view));
+	(void) g_string_assign (tree_node->name, TEXT_DATA ("name",
+							    dialog_view));
 
-	g_string_assign (tree_node->description, gtk_editable_get_chars
-			(GTK_EDITABLE (DATA ("description", dialog_view)), 0,
-			 gtk_text_get_length (GTK_TEXT (DATA ("description",
-						 dialog_view)))));
+	/* Yuk. Clean up! */
+	(void) g_string_assign (tree_node->description,
+				gtk_editable_get_chars (
+					GTK_EDITABLE (DATA ("description",
+							dialog_view)), 0,
+					gtk_text_get_length (GTK_TEXT
+						(DATA ("description",
+						       dialog_view)))));
 
-	g_string_assign (tree_node->filename, TEXT_DATA ("filename",
-				dialog_view));
+	(void) g_string_assign (tree_node->filename, TEXT_DATA
+				("filename", dialog_view));
 
 	/* There must be a better way to modify the label: */
 	gtk_label_set (GTK_LABEL (GTK_TREE_ITEM (current_tree_item)
 				->item.bin.child), TEXT_DATA ("name",
 					dialog_view));
 
-	destroy_modal (GTK_OBJECT(dialog_view), NULL);
+	gtk_object_destroy (GTK_OBJECT (dialog_view));
 }
 
-GtkWidget* create_dialog_view ()
+void create_dialog_view ()
 {
-	GtkWidget *vbox1;
+	GtkWidget *current_tree_item;
+	GtkWidget *dialog_view;
+	GtkWidget *vbox;
 	GtkWidget *vbox2;
 	GtkWidget *hbox;
 	GtkWidget *label;
 	GtkWidget *entry_name;
 	GtkWidget *text_description;
 	GtkWidget *frame;
-	GtkWidget *vbox3;
 	GtkWidget *button_view;
 	GtkWidget *button_browse;
 	GtkWidget *action_area;
 	GtkWidget *button_okay;
 	GtkWidget *button_cancel;
 
-	node *tree_node = gtk_object_get_data (GTK_OBJECT
+	node *tree_node;
+	
+	current_tree_item = GTK_WIDGET (KB_ITEM_SELECTED);
+	g_assert (current_tree_item != NULL);
+	if (GTK_IS_TREE_ITEM (current_tree_item) != 1) {
+		show_message_box ("Error!\n\n"
+				"Tree item no longer exists?\n"
+				"Aborting view operation\n");
+		return;
+	}
+
+	tree_node = gtk_object_get_data (GTK_OBJECT
 			(current_tree_item), "node");
 
+	debug_msg ("creating viewdialog\n");
 	dialog_view = gtk_dialog_new ();
+	gtk_object_set_data (GTK_OBJECT (dialog_view), "tree item",
+			current_tree_item);
+	debug_msg ("dialog_view = 0x%x\n" _ (gint)dialog_view);
 	gtk_window_set_title (GTK_WINDOW (dialog_view), "View");
 	gtk_window_set_policy (GTK_WINDOW (dialog_view), TRUE, TRUE, FALSE);
-	gtk_signal_connect_object (GTK_OBJECT (dialog_view), "delete_event",
-			GTK_SIGNAL_FUNC (destroy_modal),
-			GTK_OBJECT (dialog_view));
 
-	vbox1 = GTK_DIALOG (dialog_view)->vbox;
-	gtk_widget_show (vbox1);
+	vbox = GTK_DIALOG (dialog_view)->vbox;
 
 	vbox2 = gtk_vbox_new (FALSE, 0);
-	gtk_widget_show (vbox2);
-	gtk_box_pack_start (GTK_BOX (vbox1), vbox2, TRUE, TRUE, 0);
+	gtk_box_pack_start (GTK_BOX (vbox), vbox2, TRUE, TRUE, 0);
 	gtk_container_border_width (GTK_CONTAINER (vbox2), 10);
 
 	hbox = gtk_hbox_new (FALSE, 0);
-	gtk_widget_show (hbox);
 	gtk_box_pack_start (GTK_BOX (vbox2), hbox, TRUE, TRUE, 0);
 
 	label = gtk_label_new ("Name:");
-	gtk_widget_show (label);
 	gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 3);
 	gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
 
 	entry_name = gtk_entry_new_with_max_length (MAX_STR_LEN);
 	gtk_entry_set_text (GTK_ENTRY (entry_name), tree_node->name->str);
 	gtk_object_set_data (GTK_OBJECT (dialog_view), "name", entry_name);
-	gtk_widget_show (entry_name);
 	gtk_box_pack_start (GTK_BOX (hbox), entry_name, TRUE, TRUE, 5);
 	GTK_WIDGET_SET_FLAGS (entry_name, GTK_CAN_DEFAULT);
 	gtk_widget_grab_default (entry_name);
 
 	label = gtk_label_new ("Description:");
-	gtk_widget_show (label);
 	gtk_box_pack_start (GTK_BOX (vbox2), label, TRUE, TRUE, 3);
 	gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
 
@@ -114,80 +143,70 @@
 			tree_node->description->str,
 			-1);
 	gtk_object_set_data (GTK_OBJECT (dialog_view), "description", text_description);
-	gtk_widget_show (text_description);
 	GTK_WIDGET_SET_FLAGS (text_description, GTK_CAN_DEFAULT);
 	gtk_text_set_editable (GTK_TEXT(text_description), 1);
+	/* What is the difference? */
+	gtk_text_set_line_wrap (GTK_TEXT(text_description), 1);
 	gtk_text_set_word_wrap (GTK_TEXT(text_description), 1);
 
 	frame = gtk_frame_new (NULL);
-	gtk_widget_show (frame);
 	gtk_box_pack_start (GTK_BOX (vbox2), frame, TRUE, TRUE, 3);
 
-	vbox3 = gtk_vbox_new (FALSE, 0);
-	gtk_widget_show (vbox3);
-	gtk_container_add (GTK_CONTAINER (frame), vbox3);
+	vbox = gtk_vbox_new (FALSE, 0);
+	gtk_container_add (GTK_CONTAINER (frame), vbox);
 
 	hbox = gtk_hbox_new (FALSE, 5);
-	gtk_widget_show (hbox);
-	gtk_box_pack_start (GTK_BOX (vbox3), hbox, TRUE, TRUE, 0);
+	gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
 	gtk_container_border_width (GTK_CONTAINER (hbox), 5);
 
 	label = gtk_label_new ("Filename:");
-	gtk_widget_show (label);
 	gtk_box_pack_start (GTK_BOX (hbox), label, TRUE, TRUE, 0);
 
         entry_filename = gtk_entry_new_with_max_length (MAX_STR_LEN);
 	gtk_entry_set_text (GTK_ENTRY (entry_filename), tree_node->filename->str);
 	gtk_object_set_data (GTK_OBJECT (dialog_view), "filename", entry_filename);
-	gtk_widget_show (entry_filename);
 	gtk_box_pack_start (GTK_BOX (hbox), entry_filename, TRUE, TRUE, 0);
 
 	hbox = gtk_hbox_new (FALSE, 5);
-	gtk_widget_show (hbox);
-	gtk_box_pack_start (GTK_BOX (vbox3), hbox, TRUE, TRUE, 0);
+	gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);
 
 	button_view = gtk_button_new_with_label ("View");
-	gtk_widget_show (button_view);
 	gtk_box_pack_start (GTK_BOX (hbox), button_view, TRUE, FALSE, 0);
 	GTK_WIDGET_SET_FLAGS (button_view, GTK_CAN_DEFAULT);
-	gtk_signal_connect (GTK_OBJECT (button_view), "clicked",
-			GTK_SIGNAL_FUNC (modal2_not_implemented),
-			NULL);
+	(void) gtk_signal_connect (GTK_OBJECT (button_view), "clicked",
+				   GTK_SIGNAL_FUNC
+				   (not_implemented), NULL);
 
 	button_browse = gtk_button_new_with_label ("Browse");
-	gtk_widget_show (button_browse);
 	gtk_box_pack_start (GTK_BOX (hbox), button_browse, TRUE, FALSE, 0);
 	GTK_WIDGET_SET_FLAGS (button_browse, GTK_CAN_DEFAULT);
-	gtk_signal_connect (GTK_OBJECT (button_browse), "clicked",
-			GTK_SIGNAL_FUNC (on_button_browse_clicked),
-			NULL);
+	(void) gtk_signal_connect (GTK_OBJECT (button_browse), "clicked",
+				   GTK_SIGNAL_FUNC
+				   (on_button_browse_clicked), NULL);
 
 	action_area = GTK_DIALOG (dialog_view)->action_area;
-	gtk_widget_show (action_area);
 	gtk_container_border_width (GTK_CONTAINER (action_area), 10);
 
 	hbox = gtk_hbox_new (FALSE, 0);
-	gtk_widget_show (hbox);
 	gtk_box_pack_start (GTK_BOX (action_area), hbox, TRUE, TRUE, 0);
 
 	button_okay = gtk_button_new_with_label ("Okay");
-	gtk_widget_show (button_okay);
 	gtk_box_pack_start (GTK_BOX (hbox), button_okay, TRUE, FALSE, 5);
 	GTK_WIDGET_SET_FLAGS (button_okay, GTK_CAN_DEFAULT);
 	gtk_widget_grab_focus (button_okay);
 	gtk_widget_grab_default (button_okay);
-	gtk_signal_connect (GTK_OBJECT (button_okay), "clicked",
-			GTK_SIGNAL_FUNC (on_button_view_okay_clicked),
-			NULL);
+	(void) gtk_signal_connect (GTK_OBJECT (button_okay), "clicked",
+				   GTK_SIGNAL_FUNC
+				   (on_button_view_okay_clicked),
+				   GTK_OBJECT (dialog_view));
 
 	button_cancel = gtk_button_new_with_label ("Cancel");
-	gtk_widget_show (button_cancel);
 	gtk_box_pack_start (GTK_BOX (hbox), button_cancel, TRUE, FALSE, 5);
 	gtk_container_border_width (GTK_CONTAINER (button_cancel), 1);
 	GTK_WIDGET_SET_FLAGS (button_cancel, GTK_CAN_DEFAULT);
-	gtk_signal_connect (GTK_OBJECT (button_cancel), "clicked",
-			GTK_SIGNAL_FUNC (destroy_modal),
-			GTK_OBJECT (dialog_view));
-
-	return dialog_view;
+	(void) gtk_signal_connect_object (GTK_OBJECT (button_cancel),
+					  "clicked", GTK_SIGNAL_FUNC
+					  (gtk_object_destroy), GTK_OBJECT
+					  (dialog_view));
+	gtk_widget_show_all (dialog_view);
 }
diff -d -u -r kibble/view_dialog.h kibble-0.7.2/view_dialog.h
--- kibble/view_dialog.h	Mon Dec  7 12:27:03 1998
+++ kibble-0.7.2/view_dialog.h	Mon Mar  8 17:56:45 1999
@@ -1,5 +1,5 @@
 /* view_dialog.h
- * $Id: view_dialog.h,v 0.3 1998/11/18 00:37:17 joseph Exp $
+ * $Id: view_dialog.h,v 0.4 1998/12/21 04:23:33 joseph Exp $
  */
 
 /* kibble
@@ -20,6 +20,4 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  */
 
-GtkWidget* create_dialog_view (void);
-
-void on_button_view_okay_clicked	(GtkButton *button, gpointer user_data);
+extern void create_dialog_view			(void);
